/* Access functions for TPF thread common fields
   Copyright (C) 2003 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */


#ifndef _BITS_THRCVARS_H_                                                       //ZTPF11
#define _BITS_THRCVARS_H_                                                       //ZTPF11

#include <bits/ecbvars.h>                                                       //ZTPF11

#ifdef __cplusplus                                                              //ZTPF11
   extern "C" {                                                                 //ZTPF11
#endif                                                                          //ZTPF11


/* The thread common control block begins with an array of  */
/* pointers.  The pointers contain the addresses of varying */
/* fields.  These are the indices into that array.          */
#define __TPF_STDIO_ITCCSTDS  0                                                 //ZTPF11
#define __TPF_STDLST_ITCCSLST 1                                                 //ZTPF11
#define __TPF_CPPIO_ITCCCPPS  2                                                 //ZTPF11
#define __TPF_WCPPIO_ITCCWCPP 3                                                 //ZTPF11


typedef void **__tpf_thrc_fields_t;                                             //ZTPF11

#define __tpf_thread_common_addr()                  \
             ((__tpf_thrc_fields_t)((__tpf_ecb_page2_addr())->__ce2thrc))       //ZTPF11


/* Returns the address of the pointer to the standard       */
/* streams array (stdin, stdout, stderr)                    */
#if defined (J9ZTPF) || defined (OMRZTPF)
extern
#else
static
#endif
inline void **                                                                  //ZTPF11
__attribute__ ((__unused__))                                                    //PJ45408
__tpf_stdio_location(void)                                                      //ZTPF11
{                                                                               //ZTPF11
   __tpf_thrc_fields_t thrc;                                                    //ZTPF11

   thrc = __tpf_thread_common_addr();                                           //ZTPF11

   return (void **)(thrc[__TPF_STDIO_ITCCSTDS]);                                //ZTPF11
}                                                                               //ZTPF11


/* Returns the address of the pointer to the stdstream list */
#if defined (J9ZTPF) || defined (OMRZTPF)
extern
#else
static
#endif
inline void **                                                                  //ZTPF11
__attribute__ ((__unused__))                                                    //PJ45408
__tpf_stdiolist_location(void)                                                  //ZTPF11
{                                                                               //ZTPF11
   __tpf_thrc_fields_t thrc;                                                    //ZTPF11

   thrc = __tpf_thread_common_addr();                                           //ZTPF11

   return &(thrc[__TPF_STDLST_ITCCSLST]);                                       //ZTPF11
}                                                                               //ZTPF11


/* Returns the address of the pointer to the C++ standard   */
/* streams array (cin, cout, cerr, clog)                    */
#if defined (J9ZTPF) || defined (OMRZTPF)
extern
#else
static
#endif
inline void **                                                                  //ZTPF11
__attribute__ ((__unused__))                                                    //PJ45408
__tpf_cppio_location(void)                                                      //ZTPF11
{                                                                               //ZTPF11
   __tpf_thrc_fields_t thrc;                                                    //ZTPF11

   thrc = __tpf_thread_common_addr();                                           //ZTPF11

   return (void **)(thrc[__TPF_CPPIO_ITCCCPPS]);                                //ZTPF11
}                                                                               //ZTPF11


/* Returns the address of the pointer to the wide-character */
/* C++ streams array (wcin, wcout, wcerr, wclog)            */
#if defined (J9ZTPF) || defined (OMRZTPF)
extern
#else
static
#endif
inline void **                                                                  //ZTPF11
__attribute__ ((__unused__))                                                    //PJ45408
__tpf_wcppio_location(void)                                                     //ZTPF11
{                                                                               //ZTPF11
   __tpf_thrc_fields_t thrc;                                                    //ZTPF11

   thrc = __tpf_thread_common_addr();                                           //ZTPF11

   return (void **)(thrc[__TPF_WCPPIO_ITCCWCPP]);                               //ZTPF11
}                                                                               //ZTPF11


#ifdef __cplusplus                                                              //ZTPF11
   }                                                                            //ZTPF11
#endif                                                                          //ZTPF11

#endif                                                                          //ZTPF11
