/* bits/types.h for TPF
   Copyright (C) 2003 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

#ifndef	_BITS_TYPES_H
#define	_BITS_TYPES_H	1

#include <features.h>

#define __need_size_t
#include <stddef.h>

/* Convenience types.  */
typedef unsigned char __u_char;
typedef unsigned short int __u_short;
typedef unsigned int __u_int;
typedef unsigned long int __u_long;
typedef unsigned long int __u_quad_t;
typedef long int __quad_t;
typedef signed char __int8_t;
typedef unsigned char __uint8_t;
typedef signed short int __int16_t;
typedef unsigned short int __uint16_t;
typedef signed int __int32_t;
typedef unsigned int __uint32_t;
typedef signed long int __int64_t;
typedef unsigned long int __uint64_t;
typedef __quad_t *__qaddr_t;

typedef __uint32_t __dev_t;      /* Type of device numbers.  */
typedef __uint32_t __uid_t;		/* Type of user identifications.  */
typedef __uint32_t __gid_t;		/* Type of group identifications.  */
typedef __uint64_t __ino_t;		/* Type of file serial numbers.	 */
typedef __uint64_t __ino64_t;		/*  "" (LFS) */
typedef __uint32_t __mode_t;		/* Type of file attribute bitmasks.  */
typedef __uint32_t __nlink_t;		/* Type of file link counts.  */                 //ZTPF11
typedef __int64_t  __off_t;		/* Type of file sizes and offsets.  */
typedef __int64_t  __off64_t;		/*  "" (LFS) */
typedef __int64_t  __loff_t;		/* Type of file sizes and offsets.  */
typedef __int32_t  __pid_t;		/* Type of process identifications.  */
typedef __int64_t  __ssize_t;           /* Type of a byte count, or error.  */
typedef __uint64_t  __rlim_t;		/* Type of resource counts.  */
typedef __uint64_t  __rlim64_t;		/*  "" (LFS) */
typedef __int64_t  __blkcnt_t;		/* Type to count nr disk blocks.  */
typedef __int64_t  __blkcnt64_t;	/*  "" (LFS) */
typedef __uint64_t __fsblkcnt_t;	/* Type to count file system blocks.  */
typedef __uint64_t __fsblkcnt64_t;	/*  "" (LFS) */
typedef __uint64_t __fsfilcnt_t;	/* Type to count file system inodes.  */
typedef __uint64_t __fsfilcnt64_t;	/*  "" (LFS) */
typedef __uint32_t __id_t;		/* General type for IDs.  */

typedef struct
  {
    int val[2];                                                                 //ZTPF11
  } __fsid_t;          /* Type of file system IDs.  */


/* Everythin' else.  */
typedef int __daddr_t;			/* Type of a disk address.  */
typedef char *__caddr_t;		/* Type of a core address.  */

#ifndef ____time_t_defined                                                      //ZTPF11
   typedef long int __time_t;
   #define ____time_t_defined                                                   //ZTPF11
#endif                                                                          //ZTPF11

typedef unsigned int __useconds_t;

#ifndef ____suseconds_t_defined                                                 //ZTPF11
   typedef long int __suseconds_t;
   #define ____suseconds_t_defined                                              //ZTPF11
#endif                                                                          //ZTPF11

typedef long int __swblk_t;		/* Type of a swap block maybe?	*/
typedef long int __clock_t;
typedef int __key_t;			/* Type of a SYSV IPC key. */

/* Clock ID used in clock and timer functions.	*/
typedef int __clockid_t;

/* Timer ID returned by `timer_create'.	 */
typedef int __timer_t;

/* type to represent block size. */
typedef long int __blksize_t;

/* Number of descriptors that can fit in an `fd_set'.  */
#define __FD_SETSIZE	1024

/* Used in XTI.	 */
typedef int __t_scalar_t;
typedef unsigned int __t_uscalar_t;

/* Duplicates info from stdint.h but this is used in unistd.h.	*/
typedef long int __intptr_t;

/* Duplicate info from sys/socket.h.  */
typedef unsigned int __socklen_t;

/*********************************************************************/
/* TPF-specific convenience types                                    */
/*********************************************************************/
#ifndef _UINT_T                                                                 //ZTPF11
#define _UINT_T                                                                 //ZTPF11
typedef unsigned int   uint_t;                                                  //ZTPF11
#endif                                                                          //ZTPF11

#ifndef _UNSIGNED_T                                                             //ZTPF11
#define _UNSIGNED_T                                                             //ZTPF11
typedef unsigned long  ulong_t;                                                 //ZTPF11
typedef unsigned short ushort_t;                                                //ZTPF11
#endif                                                                          //ZTPF11

#ifndef __uchar_t                                                               //ZTPF11
#define __uchar_t                                                               //ZTPF11
typedef unsigned char  uchar_t;                                                 //ZTPF11
typedef unsigned char  uchar;                                                   //ZTPF11
#endif                                                                          //ZTPF11

#ifndef _UCHARDEF                                                               //ZTPF11
#define _UCHARDEF                                                               //ZTPF11
typedef unsigned char  UCHAR;                                                   //ZTPF11
#endif                                                                          //ZTPF11

#ifndef _BOOLDEF_                                                               //ZTPF11
#define _BOOLDEF_                                                               //ZTPF11
typedef int BOOL;                                                               //ZTPF11
#endif                                                                          //ZTPF11

/*********************************************************************/
/* 4 Byte pointer type that can operate with 8 byte pointer types.   */
/* Should be only used for typedefing structure members who have     */
/* equivalent 4 byte dsect members.                                  */
/*********************************************************************/
#if defined __SYSC__
#define PTR32ATT __ptr31
#else
#define PTR32ATT __attribute__ ((mode (SI)))
#endif
typedef void  * PTR32ATT          __ptr32_t;                                    //ZTPF11
typedef unsigned int * PTR32ATT   __uiptr32_t;                                  //ZTPF11
typedef char * PTR32ATT           __chptr32_t;                                  //ZTPF11

/*********************************************************************/
/* Miscellaneous data types                                          */
/*********************************************************************/
typedef __quad_t *qaddr_t;                                                      //ZTPF11

#ifndef __fixpt_t                                                               //ZTPF11
  typedef unsigned int  fixpt_t;                                                //ZTPF11
  #define __fixpt_t 1                                                           //ZTPF11
#endif                                                                          //ZTPF11
#define MAXHOSTNAMELEN  128                                                     //ZTPF11

#if !defined(__cc_t)                                                            //ZTPF11
  #define __cc_t 1                                                              //ZTPF11
  typedef unsigned char cc_t;                                                   //ZTPF11
#endif                                                                          //ZTPF11

#if !defined(__speed_t)                                                         //ZTPF11
  #define __speed_t 1                                                           //ZTPF11
  typedef unsigned long speed_t;                                                //ZTPF11
#endif                                                                          //ZTPF11

#if !defined(__tcflag_t)                                                        //ZTPF11
  #define __tcflag_t 1                                                          //ZTPF11
  typedef unsigned long tcflag_t;                                               //ZTPF11
#endif                                                                          //ZTPF11

#if !defined(__mtm_t)                                                           //ZTPF11
  #define __mtm_t 1                                                             //ZTPF11
  typedef unsigned long mtm_t ;                                                 //ZTPF11
#endif                                                                          //ZTPF11

#if !defined(__rdev_t)                                                          //ZTPF11
  #define __rdev_t 1                                                            //ZTPF11
  typedef unsigned int rdev_t;                                                  //ZTPF11
#endif                                                                          //ZTPF11

#if !defined(__tid_t)                                                           //ZTPF11
  #define __tid_t 1                                                             //ZTPF11
  typedef char tid_t[8];                                                        //ZTPF11
#endif                                                                          //ZTPF11

#endif /* bits/types.h */
